import * as i0 from '@angular/core';
import { EventEmitter, Directive, Output, Component, ViewChild, Input, HostListener, NgModule } from '@angular/core';
import * as i1 from 'ngx-bootstrap/dropdown';
import { BsDropdownConfig, BsDropdownModule } from 'ngx-bootstrap/dropdown';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i4 from 'ngx-bootstrap/datepicker';
import { BsDatepickerConfig, DatepickerModule, BsDatepickerModule } from 'ngx-bootstrap/datepicker';
import * as i5 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i6 from 'ngx-bootstrap/timepicker';
import { TimepickerModule } from 'ngx-bootstrap/timepicker';

class OffClickDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.offClick = new EventEmitter();
    }
    ngOnInit() {
        this.eventHandler = ($event) => {
            $event.stopPropagation();
            if (!this.elementRef.nativeElement.contains($event.target) && $event.target.localName !== 'button') {
                this.offClick.emit(null);
            }
        };
        document.addEventListener('mouseup', this.eventHandler);
    }
    ngOnDestroy() {
        document.removeEventListener('mouseup', this.eventHandler);
    }
}
OffClickDirective.ɵfac = function OffClickDirective_Factory(t) { return new (t || OffClickDirective)(i0.ɵɵdirectiveInject(i0.ElementRef)); };
OffClickDirective.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: OffClickDirective, selectors: [["", "offClick", ""]], outputs: { offClick: "offClick" } });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(OffClickDirective, [{
            type: Directive,
            args: [{
                    selector: '[offClick]'
                }]
        }], function () { return [{ type: i0.ElementRef }]; }, { offClick: [{
                type: Output
            }] });
})();

const _c0 = ["dropdown"];
function DatetimePopupComponent_ul_2_datepicker_2_Template(rf, ctx) {
    if (rf & 1) {
        const _r8 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "datepicker", 11);
        i0.ɵɵlistener("ngModelChange", function DatetimePopupComponent_ul_2_datepicker_2_Template_datepicker_ngModelChange_0_listener($event) { i0.ɵɵrestoreView(_r8); const ctx_r7 = i0.ɵɵnextContext(2); return ctx_r7.localValue = $event; })("ngModelChange", function DatetimePopupComponent_ul_2_datepicker_2_Template_datepicker_ngModelChange_0_listener() { i0.ɵɵrestoreView(_r8); const ctx_r9 = i0.ɵɵnextContext(2); return ctx_r9.onPickerChange("datepicker"); });
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r2 = i0.ɵɵnextContext(2);
        i0.ɵɵproperty("ngModel", ctx_r2.localValue)("showWeeks", ctx_r2.showWeeks)("datepickerMode", ctx_r2.datepickerMode)("minDate", ctx_r2.minDate)("maxDate", ctx_r2.maxDate)("dateDisabled", ctx_r2.dateDisabled);
    }
}
function DatetimePopupComponent_ul_2_timepicker_3_Template(rf, ctx) {
    if (rf & 1) {
        const _r11 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "timepicker", 12);
        i0.ɵɵlistener("ngModelChange", function DatetimePopupComponent_ul_2_timepicker_3_Template_timepicker_ngModelChange_0_listener($event) { i0.ɵɵrestoreView(_r11); const ctx_r10 = i0.ɵɵnextContext(2); return ctx_r10.localValue = $event; })("ngModelChange", function DatetimePopupComponent_ul_2_timepicker_3_Template_timepicker_ngModelChange_0_listener() { i0.ɵɵrestoreView(_r11); const ctx_r12 = i0.ɵɵnextContext(2); return ctx_r12.onPickerChange("timepicker"); });
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r3 = i0.ɵɵnextContext(2);
        i0.ɵɵproperty("ngModel", ctx_r3.localValue)("min", ctx_r3.minDate)("max", ctx_r3.maxDate)("hourStep", ctx_r3.hourStep)("minuteStep", ctx_r3.minuteStep)("secondsStep", ctx_r3.secondsStep)("showSeconds", ctx_r3.showSeconds)("showMeridian", ctx_r3.showMeridian);
    }
}
function DatetimePopupComponent_ul_2_button_6_Template(rf, ctx) {
    if (rf & 1) {
        const _r14 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "button", 13);
        i0.ɵɵlistener("click", function DatetimePopupComponent_ul_2_button_6_Template_button_click_0_listener() { i0.ɵɵrestoreView(_r14); const ctx_r13 = i0.ɵɵnextContext(2); return ctx_r13.onNow(); });
        i0.ɵɵtext(1);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r4 = i0.ɵɵnextContext(2);
        i0.ɵɵproperty("ngClass", ctx_r4.nowButton.cssClass);
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(ctx_r4.nowButton.label);
    }
}
function DatetimePopupComponent_ul_2_button_7_Template(rf, ctx) {
    if (rf & 1) {
        const _r16 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "button", 13);
        i0.ɵɵlistener("click", function DatetimePopupComponent_ul_2_button_7_Template_button_click_0_listener() { i0.ɵɵrestoreView(_r16); const ctx_r15 = i0.ɵɵnextContext(2); return ctx_r15.onClear(); });
        i0.ɵɵtext(1);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r5 = i0.ɵɵnextContext(2);
        i0.ɵɵproperty("ngClass", ctx_r5.clearButton.cssClass);
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(ctx_r5.clearButton.label);
    }
}
function DatetimePopupComponent_ul_2_button_9_Template(rf, ctx) {
    if (rf & 1) {
        const _r18 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "button", 13);
        i0.ɵɵlistener("click", function DatetimePopupComponent_ul_2_button_9_Template_button_click_0_listener() { i0.ɵɵrestoreView(_r18); const ctx_r17 = i0.ɵɵnextContext(2); return ctx_r17.onClose(); });
        i0.ɵɵtext(1);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r6 = i0.ɵɵnextContext(2);
        i0.ɵɵproperty("ngClass", ctx_r6.closeButton.cssClass);
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(ctx_r6.closeButton.label);
    }
}
const _c1 = function (a0, a1, a2, a3) { return { "show": a0, "body-container": a1, "dropdown": a2, "dropup": a3 }; };
function DatetimePopupComponent_ul_2_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "ul", 3);
        i0.ɵɵelementStart(1, "li", 4);
        i0.ɵɵtemplate(2, DatetimePopupComponent_ul_2_datepicker_2_Template, 1, 6, "datepicker", 5);
        i0.ɵɵtemplate(3, DatetimePopupComponent_ul_2_timepicker_3_Template, 1, 8, "timepicker", 6);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(4, "li", 7);
        i0.ɵɵelementStart(5, "span", 8);
        i0.ɵɵtemplate(6, DatetimePopupComponent_ul_2_button_6_Template, 2, 2, "button", 9);
        i0.ɵɵtemplate(7, DatetimePopupComponent_ul_2_button_7_Template, 2, 2, "button", 9);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(8, "span", 10);
        i0.ɵɵtemplate(9, DatetimePopupComponent_ul_2_button_9_Template, 2, 2, "button", 9);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        const _r0 = i0.ɵɵreference(1);
        i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction4(6, _c1, _r0.isOpen === true, ctx_r1.appendTo == "body", !ctx_r1.isDropUp, ctx_r1.isDropUp));
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", ctx_r1.showDate);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", ctx_r1.showTime);
        i0.ɵɵadvance(3);
        i0.ɵɵproperty("ngIf", ctx_r1.nowButton.show);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", ctx_r1.clearButton.show);
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", ctx_r1.closeButton.show);
    }
}
class DatetimePopupComponent {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.appendTo = undefined;
        this.valueChange = new EventEmitter();
        this.showPopup = false;
        this.showPopupChange = new EventEmitter();
        this.showDate = true;
        this.showTime = true;
        this.showWeeks = false;
        this.showMeridian = false;
        this.showSeconds = false;
        this.datepickerMode = 'day';
        this.initDate = null;
        this.minDate = null;
        this.maxDate = null;
        this.dateDisabled = [];
        this.minuteStep = 5;
        this.hourStep = 1;
        this.secondsStep = 1;
        this.localValue = null;
        this.isOpening = false;
        this.isDropUp = false;
    }
    ngOnChanges(changes) {
        if (!this.nowButton) {
            this.nowButton = { show: true, label: 'Now', cssClass: 'btn btn-secondary btn-sm' };
        }
        if (!this.clearButton) {
            this.clearButton = { show: true, label: 'Clear', cssClass: 'btn btn-secondary btn-sm' };
        }
        if (!this.closeButton) {
            this.closeButton = { show: true, label: 'Close', cssClass: 'btn btn-secondary btn-sm' };
        }
        // user maybe typing a value into an input box, so would come in as string
        if (typeof this.value === 'string') {
            // check if the string is a valid date
            if (!isNaN(new Date(this.value).getTime())) {
                this.localValue = new Date(this.value);
            }
        }
        else if (this.value) {
            this.localValue = this.value;
        }
        if (changes.showPopup && this.dropdown) {
            if (changes.showPopup.currentValue === true) {
                this.dropdown.show();
            }
            else if (changes.showPopup.currentValue === false) {
                this.dropdown.hide();
            }
        }
    }
    onWindowScroll() {
        const nativeEl = this.elementRef.nativeElement;
        const clientRect = nativeEl.getBoundingClientRect();
        const scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
        const offsetTop = clientRect.top + window.pageYOffset;
        const height = clientRect.height;
        const dropdownEl = nativeEl.children.item(0);
        const menuEl = dropdownEl.children.length > 0 ? dropdownEl.children.item(0) : null;
        let menuHeight = this.showDate && this.showTime ? 402 : this.showDate ? 300 : 102;
        if (menuEl != null) {
            // get the style
            const display = menuEl.style.display;
            menuEl.style.display = 'block';
            menuHeight = menuEl.getBoundingClientRect().height;
            menuEl.style.display = display;
        }
        if ((offsetTop - menuHeight) <= 0) {
            this.isDropUp = false;
        }
        else {
            this.isDropUp = ((offsetTop + height + menuHeight) > (scrollTop + document.documentElement.clientHeight));
        }
    }
    onOpenChange(opened) {
        if (opened === true) {
            this.isOpening = true;
            this.onWindowScroll();
            this.dropdown.show();
            setTimeout(() => this.isOpening = false, 250);
        }
        else {
            this.showPopupChange.emit(false);
        }
    }
    onNow() {
        this.localValue = new Date();
        this.onPickerChange('timepicker');
    }
    onClear() {
        this.valueChange.emit(null);
    }
    onClose() {
        this.showPopupChange.emit(false);
    }
    onOffClick($event) {
        this.showPopupChange.emit(false);
    }
    onPickerChange(picker) {
        if (this.isOpening === true) {
            return;
        }
        if (picker === 'datepicker' && this.value != null) {
            const hours = this.value.getHours();
            const minutes = this.value.getMinutes();
            const seconds = this.value.getSeconds();
            const milliseconds = this.value.getMilliseconds();
            this.localValue.setHours(hours, minutes, seconds, milliseconds);
        }
        this.valueChange.emit(this.localValue);
        if (this.showDate === true && this.showTime === false) {
            this.dropdown.hide();
        }
    }
}
DatetimePopupComponent.ɵfac = function DatetimePopupComponent_Factory(t) { return new (t || DatetimePopupComponent)(i0.ɵɵdirectiveInject(i0.ElementRef)); };
DatetimePopupComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: DatetimePopupComponent, selectors: [["datetime-popup"]], viewQuery: function DatetimePopupComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(_c0, 7);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.dropdown = _t.first);
        }
    }, hostBindings: function DatetimePopupComponent_HostBindings(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵlistener("scroll", function DatetimePopupComponent_scroll_HostBindingHandler() { return ctx.onWindowScroll(); }, false, i0.ɵɵresolveWindow)("resize", function DatetimePopupComponent_resize_HostBindingHandler() { return ctx.onWindowScroll(); }, false, i0.ɵɵresolveWindow);
        }
    }, inputs: { appendTo: "appendTo", value: "value", showPopup: "showPopup", showDate: "showDate", showTime: "showTime", showWeeks: "showWeeks", showMeridian: "showMeridian", showSeconds: "showSeconds", datepickerMode: "datepickerMode", initDate: "initDate", minDate: "minDate", maxDate: "maxDate", dateDisabled: "dateDisabled", nowButton: "nowButton", clearButton: "clearButton", closeButton: "closeButton", minuteStep: "minuteStep", hourStep: "hourStep", secondsStep: "secondsStep" }, outputs: { valueChange: "valueChange", showPopupChange: "showPopupChange" }, features: [i0.ɵɵNgOnChangesFeature], decls: 3, vars: 3, consts: [["dropdown", "", 3, "container", "dropup", "autoClose", "isOpenChange", "offClick"], ["dropdown", "bs-dropdown"], ["class", "datetime-popup dropdown-menu", "role", "menu", 3, "ngClass", 4, "dropdownMenu"], ["role", "menu", 1, "datetime-popup", "dropdown-menu", 3, "ngClass"], [1, "my-2", "mx-2"], [3, "ngModel", "showWeeks", "datepickerMode", "minDate", "maxDate", "dateDisabled", "ngModelChange", 4, "ngIf"], [3, "ngModel", "min", "max", "hourStep", "minuteStep", "secondsStep", "showSeconds", "showMeridian", "ngModelChange", 4, "ngIf"], [1, "mx-2", "mb-2"], [1, "btn-group", "float-left"], ["type", "button", 3, "ngClass", "click", 4, "ngIf"], [1, "btn-group", "float-right"], [3, "ngModel", "showWeeks", "datepickerMode", "minDate", "maxDate", "dateDisabled", "ngModelChange"], [3, "ngModel", "min", "max", "hourStep", "minuteStep", "secondsStep", "showSeconds", "showMeridian", "ngModelChange"], ["type", "button", 3, "ngClass", "click"]], template: function DatetimePopupComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0, 1);
            i0.ɵɵlistener("isOpenChange", function DatetimePopupComponent_Template_div_isOpenChange_0_listener($event) { return ctx.onOpenChange($event); })("offClick", function DatetimePopupComponent_Template_div_offClick_0_listener($event) { return ctx.onOffClick($event); });
            i0.ɵɵtemplate(2, DatetimePopupComponent_ul_2_Template, 10, 11, "ul", 2);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵproperty("container", ctx.appendTo)("dropup", ctx.isDropUp)("autoClose", false);
        }
    }, directives: [i1.BsDropdownDirective, OffClickDirective, i1.BsDropdownMenuDirective, i3.NgClass, i3.NgIf, i4.DatePickerComponent, i5.NgControlStatus, i5.NgModel, i6.TimepickerComponent], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(DatetimePopupComponent, [{
            type: Component,
            args: [{ selector: 'datetime-popup', styles: [], template: "<div [container]=\"appendTo\" (isOpenChange)=\"onOpenChange($event)\" [dropup]=\"isDropUp\" dropdown #dropdown=\"bs-dropdown\" [autoClose]=\"false\" (offClick)=\"onOffClick($event)\">\r\n  <ul class=\"datetime-popup dropdown-menu\" role=\"menu\" [ngClass]=\"{ 'show': dropdown.isOpen === true, 'body-container': appendTo == 'body', 'dropdown': !isDropUp, 'dropup': isDropUp }\" *dropdownMenu>\r\n    <li class=\"my-2 mx-2\">\r\n      <datepicker *ngIf=\"showDate\"\r\n                  [(ngModel)]=\"localValue\"\r\n                  (ngModelChange)=\"onPickerChange('datepicker')\"\r\n                  [showWeeks]=\"showWeeks\"\r\n                  [datepickerMode]=\"datepickerMode\"\r\n                  [minDate]=\"minDate\"\r\n                  [maxDate]=\"maxDate\"\r\n                  [dateDisabled]=\"dateDisabled\"></datepicker>\r\n      <timepicker *ngIf=\"showTime\"\r\n                  [(ngModel)]=\"localValue\"\r\n                  [min]=\"minDate\"\r\n                  [max]=\"maxDate\"\r\n                  [hourStep]=\"hourStep\"\r\n                  [minuteStep]=\"minuteStep\"\r\n                  [secondsStep]=\"secondsStep\"\r\n                  [showSeconds]=\"showSeconds\"\r\n                  [showMeridian]=\"showMeridian\"\r\n                  (ngModelChange)=\"onPickerChange('timepicker')\"></timepicker>\r\n    </li>\r\n    <li class=\"mx-2 mb-2\">\r\n      <span class=\"btn-group float-left\">\r\n          <button type=\"button\"\r\n                  (click)=\"onNow()\"\r\n                  *ngIf=\"nowButton.show\"\r\n                  [ngClass]=\"nowButton.cssClass\">{{ nowButton.label }}</button>\r\n          <button type=\"button\"\r\n                  (click)=\"onClear()\"\r\n                  *ngIf=\"clearButton.show\"\r\n                  [ngClass]=\"clearButton.cssClass\">{{ clearButton.label }}</button>\r\n      </span>\r\n      <span class=\"btn-group float-right\">\r\n          <button type=\"button\"\r\n                  (click)=\"onClose()\"\r\n                  *ngIf=\"closeButton.show\"\r\n                  [ngClass]=\"closeButton.cssClass\">{{ closeButton.label }}</button>\r\n      </span>\r\n    </li>\r\n  </ul>\r\n</div>\r\n" }]
        }], function () { return [{ type: i0.ElementRef }]; }, { dropdown: [{
                type: ViewChild,
                args: ['dropdown', { static: true }]
            }], appendTo: [{
                type: Input
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], showPopup: [{
                type: Input
            }], showPopupChange: [{
                type: Output
            }], showDate: [{
                type: Input
            }], showTime: [{
                type: Input
            }], showWeeks: [{
                type: Input
            }], showMeridian: [{
                type: Input
            }], showSeconds: [{
                type: Input
            }], datepickerMode: [{
                type: Input
            }], initDate: [{
                type: Input
            }], minDate: [{
                type: Input
            }], maxDate: [{
                type: Input
            }], dateDisabled: [{
                type: Input
            }], nowButton: [{
                type: Input
            }], clearButton: [{
                type: Input
            }], closeButton: [{
                type: Input
            }], minuteStep: [{
                type: Input
            }], hourStep: [{
                type: Input
            }], secondsStep: [{
                type: Input
            }], onWindowScroll: [{
                type: HostListener,
                args: ['window:scroll', []]
            }, {
                type: HostListener,
                args: ['window:resize', []]
            }] });
})();

class DatetimePopupModule {
}
DatetimePopupModule.ɵfac = function DatetimePopupModule_Factory(t) { return new (t || DatetimePopupModule)(); };
DatetimePopupModule.ɵmod = /*@__PURE__*/ i0.ɵɵdefineNgModule({ type: DatetimePopupModule });
DatetimePopupModule.ɵinj = /*@__PURE__*/ i0.ɵɵdefineInjector({ providers: [BsDatepickerConfig, BsDropdownConfig], imports: [[
            CommonModule,
            FormsModule,
            DatepickerModule,
            TimepickerModule,
            BsDatepickerModule,
            BsDropdownModule,
        ]] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(DatetimePopupModule, [{
            type: NgModule,
            args: [{
                    declarations: [DatetimePopupComponent, OffClickDirective],
                    imports: [
                        CommonModule,
                        FormsModule,
                        DatepickerModule,
                        TimepickerModule,
                        BsDatepickerModule,
                        BsDropdownModule,
                    ],
                    exports: [DatetimePopupComponent],
                    providers: [BsDatepickerConfig, BsDropdownConfig]
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(DatetimePopupModule, { declarations: [DatetimePopupComponent, OffClickDirective], imports: [CommonModule,
            FormsModule,
            DatepickerModule,
            TimepickerModule,
            BsDatepickerModule,
            BsDropdownModule], exports: [DatetimePopupComponent] });
})();

/*
 * Public API Surface of ngx-bootstrap-datetime-popup
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DatetimePopupComponent, DatetimePopupModule };
//# sourceMappingURL=ngx-bootstrap-datetime-popup.mjs.map
